package cpcns.dingZhi.zhuanYeWenJian.controller;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.common.User;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.base.configuration.AppConfiguration;
import cpcns.base.generic.ResultMessage;
import cpcns.dangAnBase.base.controller.DangAnBaseController;
import cpcns.danganmenlei.model.GDangAnMenLei;
import cpcns.danganmenlei.service.IGDangAnMenLeiService;
import cpcns.dingZhi.zhuanYeAnJuan.model.zhuanYeAnJuan;
import cpcns.dingZhi.zhuanYeAnJuan.service.IZhuanYeAnJuanService;
import cpcns.dingZhi.zhuanYeWenJian.model.zhuanYeWenJian;
import cpcns.dingZhi.zhuanYeWenJian.service.IZhuanYeWenJianService;
import cpcns.printManager.PrintUtil;
import cpcns.utils.CommStatic;
import cpcns.utils.PagerVO;
import cpcns.utils.tool;
import java.io.File;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;

@Controller
@RequestMapping({"zhuanYeWenJianController"})
public class ZhuanYeWenJianController extends DangAnBaseController {
  @Autowired
  private IZhuanYeWenJianService zhuanYeWenJianService;
  
  @Autowired
  private IGDangAnMenLeiService gDangAnMenLeiService;
  
  @Autowired
  private IZhuanYeAnJuanService zhuanYeAnJuanService;
  
  @RequestMapping({"/toList.do"})
  public String toList(HttpServletRequest request, Model model) {
    String moBan = request.getParameter("moBan");
    model.addAttribute("moBan", moBan);
    boolean fl = this.zhuanYeWenJianService.getInitVal("miJiShow", "miJiShow");
    if (fl)
      model.addAttribute("miJiShow", Integer.valueOf(1)); 
    return "dingZhi/zhuanYeWenJian/zhuanYeWenJian_list";
  }
  
  @RequestMapping({"/toAdd.do"})
  public String toAdd(HttpServletRequest request, Model model) {
    User user = getCurrentUser();
    zhuanYeWenJian obj = new zhuanYeWenJian();
    String menLei = request.getParameter("menLei");
    String glbs = request.getParameter("hangBiaoShi");
    String state = request.getParameter("state");
    String moBan = request.getParameter("moBan");
    model.addAttribute("moBan", moBan);
    Integer guanLianBiaoShi = Integer.valueOf(StringUtils.isNotBlank(glbs) ? Integer.parseInt(glbs) : 0);
    String view = "zhuanYeWenJian_edit";
    if (guanLianBiaoShi.intValue() > 0) {
      zhuanYeAnJuan aj = (zhuanYeAnJuan)this.zhuanYeAnJuanService.getById(zhuanYeAnJuan.class, guanLianBiaoShi);
      obj.setQuanZongHao(aj.getQuanZongHao());
      obj.setMuLuHao(aj.getMuLuHao());
      obj.setCunFangWeiZhi(aj.getCunFangWeiZhi());
      if (!"TDCGWS".equals(menLei) && !"HYWS".equals(menLei))
        obj.setBiaoTi(aj.getBiaoTi()); 
      obj.setGuanLianBiaoShi(aj.getHangBiaoShi());
      obj.setGuiDangNianDu(aj.getGuiDangNianDu());
      obj.setFenLeiHao(aj.getFenLeiHao());
      if (StringUtils.isNotBlank(moBan) && moBan.equals("1")) {
        String jspPath = request.getRealPath("WEB-INF/views/dingZhi/zhuanYeWenJian/");
        String dWQuanZongHao = AppConfiguration.getConfigValue("CPCNS_QUANZHONGHAO");
        String view2 = String.valueOf(jspPath) + "/" + view + "_" + dWQuanZongHao + ".jsp";
        File viewFile = new File(view2);
        if (viewFile.exists()) {
          obj.setAnJuanHao((String)aj.getXuHao());
          obj.setFenLeiMingCheng(aj.getFenLeiMingCheng());
          obj.setMuLuHao("");
          obj.setCunFangWeiZhi("");
          view = String.valueOf(view) + "_" + dWQuanZongHao;
        } else {
          obj.setAnJuanHao((String)aj.getXuHao());
          obj.setZeRenZhe(aj.getBiaoTi());
        } 
      } else if (menLei.equals("HYWS")) {
        obj.setAnJuanHao(aj.getAnJuanHao());
        view = "hunYinWenJian_edit";
      } else if (menLei.equals("XZQL")) {
        obj.setAnJuanHao((String)aj.getXuHao());
        obj.setZeRenZhe(aj.getBiaoTi());
        obj.setFenLeiMingCheng(aj.getFenLeiMingCheng());
        obj.setFenLeiHao(aj.getFenLeiHao());
        obj.setSanJiFenLeiMingCheng(aj.getSanJiFenLeiMingCheng());
        obj.setSanJiFenLeiHao(aj.getSanJiFenLeiHao());
      } else if (menLei.equals("TDYB") || menLei.equals("ZCPG")) {
        obj.setAnJuanHao(aj.getAnJuanHao());
        obj.setBaoGuanQiXian(aj.getBaoGuanQiXian());
        obj.setMiJi(aj.getMiJi());
      } else {
        obj.setAnJuanHao((String)aj.getXuHao());
        obj.setZeRenZhe(aj.getBiaoTi());
      } 
    } else if (StringUtils.isNotBlank(moBan) && moBan.equals("1")) {
      String jspPath = request.getRealPath("WEB-INF/views/dingZhi/zhuanYeWenJian/");
      String dWQuanZongHao = AppConfiguration.getConfigValue("CPCNS_QUANZHONGHAO");
      String view2 = String.valueOf(jspPath) + "/" + view + "_" + dWQuanZongHao + ".jsp";
      File viewFile = new File(view2);
      if (viewFile.exists())
        view = String.valueOf(view) + "_" + dWQuanZongHao; 
    } else if (menLei.equals("HYWS")) {
      view = "hunYinWenJian_edit";
    } 
    obj.setMenLei(menLei);
    obj.setZhuangTai(Integer.valueOf(2));
    GDangAnMenLei dam = this.gDangAnMenLeiService.getByFenLeiHao(menLei);
    if (dam != null) {
      model.addAttribute("dangHaoGuiZe", dam.getDangHaoGuiZe());
      model.addAttribute("fenGeFu", dam.getFenGeFu());
      model.addAttribute("xuHaoGuiZe", dam.getZiFuDaiMa());
      model.addAttribute("qiDongDangHao", dam.getQiDongDangHao());
    } 
    if (user != null) {
      obj.setLiJuanDanWeiMingCheng(user.findRootBuMenMingCheng());
      obj.setLiJuanDanWeiBiaoShi(Integer.valueOf(user.findRootBuMenBiaoShi()));
      obj.setLURURENBIAOSHI(Integer.valueOf(user.getBiaoShi().intValue()));
      obj.setLuRuRenMingCheng(user.getMingCheng());
    } 
    model.addAttribute("state", state);
    model.addAttribute("zhuanYeWenJian", obj);
    return "dingZhi/zhuanYeWenJian/" + view;
  }
  
  @RequestMapping({"/query.do"})
  public String query(HttpServletRequest request, HttpServletResponse response, Model model) {
    try {
      Map<String, Object> map = tool.getRequestParamsMaps(request);
      pageBase(model);
      String menLei = request.getParameter("menLei");
      String paixutiaojian = this.zhuanYeAnJuanService.paiXuTiaoJian(String.valueOf(this.table.toUpperCase()) + "_" + menLei);
      if (StringUtils.isBlank(paixutiaojian))
        paixutiaojian = "quanZongHao,guiDangNianDu,baoGuanQiXian,xuHao asc"; 
      System.out.println(paixutiaojian);
      PagerVO pagevo = this.zhuanYeWenJianService.query_SQL(getUser(), this.start, this.number, this.table, map, CommStatic.getOrderBy(request, paixutiaojian));
      String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo).replaceAll(" 00:00:00", "").replaceAll(":00", "")
        .replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("", "").replaceAll("BIAOTI", "biaoTi").replaceAll("QUANZONGHAO", "quanZongHao")
        .replaceAll("GUIDANGNIANDU", "guiDangNianDu").replaceAll("MULUHAO", "muLuHao").replaceAll("CUNFANGWEIZHI", "cunFangWeiZhi")
        .replaceAll("DANGHAO", "dangHao").replaceAll("FENLEIMINGCHENG", "fenLeiMingCheng").replaceAll("FENLEIHAO", "fenLeiHao").replaceAll("ZERENZHE", "zeRenZhe")
        .replaceAll("XINGBIE", "xingBie").replaceAll("SIWANGSHIJIAN", "siWangShiJian").replaceAll("ANJUANHAO", "anJuanHao").replaceAll("MIJI", "miJi");
      write(response, jsonString);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return null;
  }
  
  @RequestMapping({"/saveOrUpdate.do"})
  public void save(HttpServletRequest request, HttpServletResponse response, zhuanYeWenJian obj) {
    ResultMessage rm = new ResultMessage();
    String info = "";
    try {
      if (obj != null) {
        Map<String, String> map1 = new HashMap<>();
        map1.put("table", this.table);
        map1.put("server", this.server);
        map1.put("guiDangNianDu", (new StringBuilder(String.valueOf(obj.getGuiDangNianDu()))).toString());
        map1.put("quanZongHaoString", obj.getQuanZongHao());
        map1.put("baoGuanQiXian", obj.getBaoGuanQiXian());
        map1.put("biaoTiString", obj.getBiaoTi());
        map1.put("menLeiString", obj.getMenLei());
        map1.put("zhuangTai_notin", "3,4");
        if (obj.getHangBiaoShi() != null && obj.getHangBiaoShi().intValue() > 0)
          map1.put("hangBiaoShi_not", String.valueOf(obj.getHangBiaoShi())); 
        String rizhi = "";
        if (obj.getHangBiaoShi() != null && obj.getHangBiaoShi().intValue() > 0) {
          rizhi = "修改";
          this.zhuanYeWenJianService.update(obj);
        } else {
          rizhi = "新增";
          obj.setHangBiaoShi(Integer.valueOf(this.zhuanYeWenJianService.getPk(this.table)));
          obj.setZhuangTai(Integer.valueOf(2));
          obj.setDengJiShiJian(new Date());
          if (StringUtils.isBlank(String.valueOf(obj.getGuanLianBiaoShi())))
            obj.setGuanLianBiaoShi(Integer.valueOf(0)); 
          this.zhuanYeWenJianService.save(obj);
        } 
        rm.setSuccess(true);
        info = "保存成功！";
        rm.setBeizhu((String)obj.getHangBiaoShi());
        this.zhuanYeWenJianService.addDA_RiZhi(getCurrentUser(), this.server, this.table, obj.getHangBiaoShi(), obj.getBiaoTi(), rizhi);
      } else {
        rm.setSuccess(false);
        info = "数据转换错误！";
      } 
    } catch (Exception e) {
      e.printStackTrace();
      rm.setSuccess(false);
      info = "操作失败！";
    } 
    rm.setInfo(info);
    responseWriter(response, rm.toString());
  }
  
  @RequestMapping({"/open.do"})
  public String open(HttpServletRequest request, HttpServletResponse response, Model model) {
    String view = "zhuanYeWenJian_edit";
    try {
      Integer hangBiaoShi = Integer.valueOf(Integer.parseInt(request.getParameter("hangBiaoShi")));
      String ids = request.getParameter("keyWordResult");
      model.addAttribute("keyWordResult", ids);
      String moBan = request.getParameter("moBan");
      model.addAttribute("moBan", moBan);
      zhuanYeWenJian obj = (zhuanYeWenJian)this.zhuanYeWenJianService.getById(zhuanYeWenJian.class, hangBiaoShi);
      if (StringUtils.isNotBlank(obj.getMenLei())) {
        GDangAnMenLei dam = this.gDangAnMenLeiService.getByFenLeiHao(obj.getMenLei());
        if (dam != null) {
          model.addAttribute("dangHaoGuiZe", dam.getDangHaoGuiZe());
          model.addAttribute("fenGeFu", dam.getFenGeFu());
          model.addAttribute("xuHaoGuiZe", dam.getZiFuDaiMa());
          model.addAttribute("qiDongDangHao", dam.getQiDongDangHao());
        } 
      } 
      if (obj.getMenLei().equals("HYWS"))
        view = "hunYinWenJian_edit"; 
      if (StringUtils.isNotBlank(moBan) && moBan.equals("1")) {
        String jspPath = request.getRealPath("WEB-INF/views/dingZhi/zhuanYeWenJian/");
        String dWQuanZongHao = AppConfiguration.getConfigValue("CPCNS_QUANZHONGHAO");
        String view2 = String.valueOf(jspPath) + "/" + view + "_" + dWQuanZongHao + ".jsp";
        File viewFile = new File(view2);
        if (viewFile.exists())
          view = String.valueOf(view) + "_" + dWQuanZongHao; 
      } 
      String czlx = request.getParameter("czlx");
      String state = request.getParameter("state");
      model.addAttribute("czlx", czlx);
      model.addAttribute("state", state);
      model.addAttribute("zhuanYeWenJian", obj);
      this.zhuanYeWenJianService.addDA_RiZhi(getCurrentUser(), this.server, this.table, hangBiaoShi, obj.getBiaoTi(), "查看");
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return "dingZhi/zhuanYeWenJian/" + view;
  }
  
  @RequestMapping({"/delete.do"})
  public void delete(HttpServletRequest request, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String info = "";
    try {
      String hangBiaoShi = request.getParameter("hangBiaoShi");
      String biaoTi = request.getParameter("biaoTi");
      if (StringUtils.isNotBlank(hangBiaoShi)) {
        User user = getCurrentUser();
        rm.setSuccess(true);
        info = "删除成功！";
        this.zhuanYeWenJianService.deleteBySQL(user, this.table, Integer.valueOf(Integer.parseInt(hangBiaoShi)));
        this.zhuanYeWenJianService.addDA_RiZhi(user, this.server, this.table, Integer.valueOf(Integer.parseInt(hangBiaoShi)), biaoTi, "删除");
      } else {
        rm.setSuccess(false);
        info = "获取参数失败，无法删除，请联系管理员！";
      } 
    } catch (Exception e) {
      e.printStackTrace();
      rm.setSuccess(false);
      info = "删除失败！";
    } 
    rm.setInfo(info);
    responseWriter(response, rm.toString());
  }
  
  @RequestMapping({"/Print.do"})
  public String damlPrint(HttpServletRequest request, HttpServletResponse response, Model model) throws Exception {
    User user = getCurrentUser();
    String printService = AppConfiguration.getConfigValue("printServlet");
    String menLei = request.getParameter("menLei");
    String moban = "danganmulu_" + menLei + ".jasper";
    Map<String, Object> map = tool.getRequestParamsMaps(request);
    HashMap<String, Object> params = new HashMap<>();
    pageBase(model);
    List<Map<String, Object>> list = this.zhuanYeWenJianService.getDate(this.table, map, user);
    List<Map<String, Object>> listAll = new ArrayList<>();
    if ("JSZCWS".equals(menLei) && list.size() > 0) {
      for (Map<String, Object> m : list) {
        for (Map.Entry<String, Object> entry : m.entrySet()) {
          String key = entry.getKey();
          String value = (String)entry.getValue();
          if ("XINGBIE".equals(key) && "1".equals(value))
            entry.setValue("初级"); 
          if ("XINGBIE".equals(key) && "2".equals(value))
            entry.setValue("中级"); 
          if ("XINGBIE".equals(key) && "3".equals(value))
            entry.setValue("副高级"); 
          if ("XINGBIE".equals(key) && "4".equals(value))
            entry.setValue("正高级"); 
        } 
        listAll.add(m);
      } 
      listAll = CommStatic.print_BuKongXing(listAll, 10);
      PrintUtil.printService(request, user, printService, moban, listAll, params, "zyda");
      return "print/check";
    } 
    if ("SWGBWS".equals(menLei) && list.size() > 0) {
      for (Map<String, Object> m : list) {
        for (Map.Entry<String, Object> entry : m.entrySet()) {
          String key = entry.getKey();
          String value = (String)entry.getValue();
          if ("XINGBIE".equals(key) && "1".equals(value))
            entry.setValue("男"); 
          if ("XINGBIE".equals(key) && "0".equals(value))
            entry.setValue("女"); 
          if ("SIWANGSHIJIAN".equals(key) && StringUtils.isNotBlank(value))
            entry.setValue(value.replaceAll("=", "年").replaceAll("-", "月")); 
          if ("SIWANGSHIJIAN".equals(key) && StringUtils.isNotBlank(value))
            entry.setValue(value.replaceAll("=", "年").replaceAll("-", "月")); 
        } 
        listAll.add(m);
      } 
      listAll = CommStatic.print_BuKongXing(listAll, 10);
      PrintUtil.printService(request, user, printService, moban, listAll, params, "zyda");
      return "print/check";
    } 
    if ("GZWS".equals(menLei) && list.size() > 0) {
      list = CommStatic.print_BuKongXing(list, 10);
      PrintUtil.printService(request, user, printService, moban, list, params, "zyda");
      return "print/check";
    } 
    list = CommStatic.print_BuKongXing(list, 10);
    PrintUtil.printService(request, user, printService, moban, list, params, "zyda");
    return "print/check";
  }
  
  @RequestMapping({"/shiFouYouNeiJian.do"})
  public void shiFouYouNeiJian(HttpServletRequest request, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      String sql = "select 1  from d_zhuanyewenjian  where guanlianbiaoshi='" + hangBiaoShi + "' and rownum =1 ";
      List<BigDecimal> list = this.zhuanYeWenJianService.getList(sql);
      int isExist = 0;
      if (!list.isEmpty()) {
        BigDecimal bigDecimal = list.get(0);
        isExist = Integer.parseInt(bigDecimal.toString());
        System.out.println("----------------");
        System.out.println(list.get(0));
        System.out.println("----------------");
      } 
      if (isExist == 1) {
        rm.setSuccess(false);
        rm.setInfo("本卷行标识在文件列表有关联，不可删除");
      } else {
        rm.setSuccess(true);
        rm.setInfo("本卷行标识在文件列表无关联，可放心删除");
      } 
    } else {
      rm.setSuccess(false);
      rm.setInfo("参数错误");
    } 
    responseWriter(response, rm.toString());
  }
}
